/*
SECTRET KILLER MODE BY GREASERPIRATE
based on OrbitalDecay's Zombie Mod
*/

#define TEAM_killer     TEAM_OMEGA
#define TEAM_citizen      TEAM_ALPHA

//number of victims the killer claims
int headcount = 0;
//collateral damage caused by teamkilling
int chaos = 0;

struct killerservmode : servmode
{
    vector<clientinfo *> killerList;
    vector<clientinfo *> citizenList;

    /* This is called whenever a player enters the game. */
    void entergame(clientinfo *ci)
    {
    }

    /* This is called whenever a player leaves the game */
    void leavegame(clientinfo *ci, bool disconnecting = false)
    {
        /* Remove the player from the killer and citizen lists, if they're on
           them. */
        int n;

        n = killerList.find(ci);
        if (n >= 0)
            killerList.remove(n);

        n = citizenList.find(ci);
        if (n >= 0)
            citizenList.remove(n);
    }

    /* This is called every time a player moves */
    void moved(clientinfo *ci, const vec &oldpos, const vec &newpos)
    {
    }

    /* This is called when the server needs to know if a player can join a game */
    bool canspawn(clientinfo *ci, bool tryspawn = false)
    {
        /* Everybody can join this party */
        return true;
    }

    /* This is called whenever someone spawns */
    void spawned(clientinfo *ci)
    {
        /* If there aren't enough killers, make some*/
        if (killerList.length() < GAME(killers) && citizenList.length() > 1 && iscitizen(ci))
        {
            corrupt(ci);
	}
        /* Prevent players from respawning as killers by changing weapons, suiciding, etc. Killers recieve no points from doing this. */
        if (iskiller(ci))
        {	
            	int n = killerList.find(ci);
		killerList.remove(n);
            	int newkillernum = rand() % citizenList.length();
            	clientinfo *newkiller = citizenList[newkillernum];
            	corrupt(newkiller);
		//make previous killer citizen
                citizenList.add(ci);		
        }
        /* If the player is a citizen, tell them so.  If they are not on the
           citizen team, put them there. */
        else if (iscitizen(ci))
        {
            ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fgYou are a normal citizen. Headshot the Killer, but don't kill innocents!");
        }

        /* If a player is neither a citizen nor a killer, make them a citizen. */
        else
        {
            ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\fgYou are a normal citizen. Headshot the Killer, but don't kill innocents!");
            citizenList.add(ci);
        }
    }

    /* This is called when a player kills another player.  Returns the number of
       points assigned. Does not seem to be working, possibly overriden somewhere else, but using "givepoints" works just fine */
    int points(clientinfo *victim, clientinfo *actor)
    {
	return 1;
    }

    /* This is called whenever someone dies */
    void died(clientinfo *victim, clientinfo *actor = NULL)
    {
	//GREASERPIRATE: I think this is how you add points, right?	
	if (iscitizen(actor) && iscitizen(victim))	
	{	
		givepoints(actor, (GAME(killerteamkillpenalty) + GAME(fragbonus)) * -1);
		givepoints(victim, GAME(killerdyingpenalty) * -1);
		//Add 1 to the "chaos" value every time a citizen(not a bot) teamkills.
		if(actor->state.aitype < 0)
		{
			chaos += 1;
		}
	}
	else if (iscitizen(actor) && iskiller(victim))
	{
		//The bounty for cathing Killers is determined by "killerbounty"
		givepoints(actor, GAME(killerbounty));
		//this gives all the players some points when a killer is caught.
		for ( int n = 0; n < citizenList.length(); n++)
		{
			clientinfo *recipient = citizenList[n];
			if (iscitizen(recipient))
			{
				givepoints(recipient, GAME(killermutualbounty));
			}
		}
	}
	//Don't immediately give killers points, raise the "headcount" var and wait until they die to give them their points.
	else if (iskiller(actor) && iscitizen(victim))
	{
		givepoints(actor, GAME(fragbonus) * -1);
		headcount += 1;
	}
	if (iskiller(victim))
        {
            int n = killerList.find(victim);
            if (n >= 0)
            {
		//announce their death
		string msg;
		//both are bots:           	
		if ((actor) && (victim->state.aitype >= 0) && (actor->state.aitype >= 0))
		{            	
			formatstring(msg)("%s [%d] was brought to justice by %s [%d]",victim->name, victim->clientnum, actor->name, actor->clientnum);
		}
		//actor is human:		
		else if ((actor) && (victim->state.aitype >= 0) && (actor->state.aitype < 0))
		{            	
			formatstring(msg)("%s [%d] was brought to justice by %s",victim->name, victim->clientnum, actor->name);
		}
		//victim is human:		
		else if ((actor) && (victim->state.aitype < 0) && (actor->state.aitype >= 0))
		{            	
			formatstring(msg)("%s was brought to justice by %s [%d]",victim->name, actor->name, actor->clientnum);
		}
		//both are humans:		
		else if ((actor) && (victim->state.aitype < 0) && (actor->state.aitype < 0))
		{            	
			formatstring(msg)("%s was brought to justice by %s",victim->name, actor->name);
		}
		else
		{
			formatstring(msg)("%s was brought to justice!",victim->name);
		}
                ancmsgft(-1, S_GUIBACK, CON_EVENT, msg);
		conoutft(1, "%s", msg);
		// Killers stop being killers               
		killerList.remove(n);
		//killers finally get their reward, but also get a penalty for dying
		givepoints(victim, GAME(fragbonus) * headcount);
		givepoints(victim, GAME(killerchaospoints) * chaos);
		givepoints(victim, GAME(killerjusticepenalty) * -1);
		headcount = 0;
		chaos = 0;
		//another killer is chosen
            	int newkillernum = rand() % citizenList.length();
            	clientinfo *newkiller = citizenList[newkillernum];
            	corrupt(newkiller);
		//the previous killer becomes a normal citizen
                citizenList.add(victim);
            }                
        }

    }

    /* In theory, this is called when someone changes teams.  I don't think
       it is actually used in practice. */
    void changeteam(clientinfo *ci, int oldteam, int newteam)
    {
    }
    
    /* Called when a client first connects.  Used for low level networking stuff
       if there is any extra information we want to append to the packet. */
    void initclient(clientinfo *ci, packetbuf &p, bool connecting)
    {
    }

    /* Called every frame */
    void update()
    {
        int live_killers = 0;
        loopv(killerList)
        {
            /* Count the number of real killers (non-bot) */
            if (killerList[i]->state.aitype < 0)
            {
                live_killers++;
            }
        }

        /* If no killers are left, randomly corrupt someone */
        if (killerList.length() == 0 && citizenList.length() > 1)
        {
            int n = rand() % citizenList.length();
            clientinfo *victim = citizenList[n];
            corrupt(victim);
        }
    }

    /* Called when the server is reset */
    void reset(bool empty)
    {
        killerList.shrink(0);
        citizenList.shrink(0);
    }

    /* No clue */
    void layout()
    {
    }

    /* This is called when intermission begins */
    void intermission()
    {
    }

    /* This is called when someone actually deals damage to someone else */
    bool damage(clientinfo *target,
                clientinfo *actor,
                int damage,
                int weap,
                int flags,
                const ivec &hitpush = ivec(0, 0, 0))
    {
        return true;
    }

    /* Called before damage is dealt */
    void dodamage(clientinfo *target,
                  clientinfo *actor,
                  int &damage,
                  int &hurt,
                  int &weap,
                  int &flags,
                  const ivec &hitpush = ivec(0, 0, 0))
    {
        /* Damage dealt by killers is scaled by sv_killerdamage */
        if (iskiller(target))
        {
	    /* Undo whatever damage has already been applied */
            target->state.health += damage;

            /*Killers always take damage from headshots, but body damage is scaled*/
            if (iskiller(target) && hithead(flags))
	    {
            	target->state.health -= damage;
	    }
            else if (iskiller(target) && !hithead(flags))
	    {
		//scale damage to "killerbodydamage"   	
		damage *= GAME(killerbodydamage); //scale damage
		//add one damage points for rounding, but not if the weap is Flamer
		if ((weap != 7) && (weap != 17) && (GAME(killerbodydamage) != 0))
		{
		damage += 1;
		}
	    	target->state.health -= damage; //re-apply
	    }
            if (target->state.health <= 0)
                flags |= HIT_KILL;
        }
	else if (iscitizen(target))
	{
	    target->state.health += damage; //undo damage
	    damage *= GAME(killerdamage); //scale damage
	    target->state.health -= damage; //re-apply
	}
    }

    /* Called every frame with regen info... does not seem to be working */
    void regen(clientinfo *ci, int &total, int &amt, int &delay)
    {
    }

    /* Let players change teams */
    void setteam(clientinfo *ci, int team)
    {
    }

    /* Turn a player into a killer */
    void corrupt(clientinfo *ci)
    {
        int n;
        n = citizenList.find(ci);
        if (n >= 0)
            citizenList.remove(n);

        if (!iskiller(ci))
        {
            /* Only announce corruptions of real players (not bots) */
            ancmsgft(ci->clientnum, S_GUIBACK, CON_EVENT, "\frYou are a killer! Frag everyone you can, but don't let them catch you!");
            killerList.add(ci);
            ci->state.health = 100;
            sendf(-1, 1, "ri4", N_REGEN, ci->clientnum, 100, 0);
        }
    }

    /* Returns true if a player is a killer, false otherwise */
    bool iskiller(clientinfo *ci)
    {
        return (killerList.find(ci) >= 0);
    }

    /* Returns true if a player is a citizen, false otherwise */
    bool iscitizen(clientinfo *ci)
    {
        return (citizenList.find(ci) >= 0);
    }

} killermut; 
